//
// errorinfo.h
//
#ifndef _ERRORINFO_H_
#define _ERRORINFO_H_

#include "common.h"
#include "wx/wx.h"

// G[^Cv
typedef enum enumPsErrType {
	psOK = 0,
	psError,
	psWarning
} PsErrType;

// G[R[h
typedef enum enumPsErrCode {
	psErrNone = 0,
	psErrFileNotFound,
	psErrCannotOpen,
	pwErrCannotWrite,
	psErrFileIsEmpty,
	pwErrSameFile,
	psErrFileIsEncrypted,
	psErrBasic,
	psErrParseBasic,
	psErrInvalidString,
	psInfoFileInApp,
	psInfoContinue,
	psErrUnknown
} PsErrCode;

// G[ۑp
class PsErrInfo
{
private:
	PsErrType mType;
	PsErrCode mCode;
	wxString  mMsg;
	int       mLine;

public:
	PsErrInfo();
	~PsErrInfo();

	// G[bZ[W
	wxString ErrMsg(PsErrCode code);
	// G[Zbg
	void SetInfo(int line, PsErrType type, PsErrCode code, const wxString &msg = wxEmptyString);
	// G[Zbg
	void SetInfo(int line, PsErrType type, PsErrCode code1, PsErrCode code2, const wxString &msg = wxEmptyString);

	// gui bZ[WBOX
	void ShowMsgBox(wxWindow *win = 0);

};

#endif /* _ERRORINFO_H_ */
