//
// maptable.h
//
#ifndef _MAPTABLE_H_
#define _MAPTABLE_H_

#include "common.h"
#include "wx/wx.h"
#include "wx/dynarray.h"

// }bsOe[uItem
class CodeMapItem
{
public:
	long     code;
	wxString str;
	wxString str_upper;
	wxString attr;
	wxUint8 *bytes;
	size_t   bytes_length;
public:
	CodeMapItem();
	CodeMapItem(const long &new_code, const wxString &new_str, const wxString &new_attr = wxEmptyString);
	~CodeMapItem();
	CodeMapItem &operator=(const CodeMapItem &item);
	// codev邩
	bool CmpCode(long code_name);
	// strv邩
	bool CmpStr(const wxString &str_name);
	// strɎw肵񂪊܂܂邩(Ov)
	bool FindStr(const wxString &str_name, bool case_insensitive = false);
	// bytesɎw肵oCg񂪊܂܂邩(Ov)
	bool FindBytes(const wxUint8 *bytes_name);
	// attrɎw肵񂪊܂܂邩
	bool FindAttr(const wxString &attr_name);
};

// }bsOe[uItemArray
WX_DECLARE_OBJARRAY(CodeMapItem, CodeMapItems);

// }bsOe[uSection
class CodeMapSection
{
public:
	wxString     name;
	CodeMapItems items;
public:
	CodeMapSection(const wxString &new_name);
	bool CmpSection(const wxString &section_name);
	// ACeǉ
	void AddItem(const CodeMapItem *new_item);
	// ACeǉ
	void AddItem(const long &new_code, const wxString &new_str, const wxString &new_attr = wxEmptyString);
	// ACeT(code)
	// attrw肵ꍇAattr܂܂̂i荞݂ށB
	// matching=falseɂattr܂܂Ȃ̂i荞ށB
	CodeMapItem *FindByCode(long code, const wxString &attr = wxEmptyString, bool matching = true);
	// ACeT(str)(Ov & Œv)
	// attrw肵ꍇAattr܂܂̂i荞݂ށB
	// matching=falseɂattr܂܂Ȃ̂i荞ށB
	CodeMapItem *FindByStr(const wxString &str, bool case_insensitive = false, const wxString &attr = wxEmptyString, bool matching = true);
	// ACeT(bytes)(Ov & Œv)
	// attrw肵ꍇAattr܂܂̂i荞݂ށB
	// matching=falseɂattr܂܂Ȃ̂i荞ށB
	CodeMapItem *FindByBytes(const wxUint8 *bytes, const wxString &attr = wxEmptyString, bool matching = true);
};

// }bsOe[uSectionArray
WX_DECLARE_OBJARRAY(CodeMapSection, CodeMapSections);

// }bsOe[u{
class CodeMapTable
{
private:
	CodeMapSections sections;
	CodeMapSection *current_section;
public:
	CodeMapTable();
	// ZNVǉ
	void AddSection(const wxString &section_name);
	// ZNVT
	bool FindSection(const wxString &section_name);
	// ݂̃ZNVԂ
	CodeMapSection *GetCurrentSection();
	// ZNVԂ
	void GetAllSectionNames(wxArrayString &section_names);
	wxString &GetSectionName(size_t index);
	// ACeǉ
	void AddItem(const long &new_code, const wxString &new_str, const wxString &new_attr = wxEmptyString);
	// ACeT(code)
	CodeMapItem *FindByCode(long code, const wxString &attr = wxEmptyString, bool matching = true);
	// ACeT(str)(Ov & Œv)
	CodeMapItem *FindByStr(const wxString &str, bool case_insensitive = false, const wxString &attr = wxEmptyString, bool matching = true);
	// ACeT(bytes)(Ov & Œv)
	CodeMapItem *FindByBytes(const wxUint8 *bytes, const wxString &attr = wxEmptyString, bool matching = true);
	// SZNVŃACeT(code)
	CodeMapItem *FindByCodeInAllSections(long code, const wxString &attr = wxEmptyString, bool matching = true);
	// SZNVŃACeT(str)(Ov & Œv)
	CodeMapItem *FindByStrInAllSections(const wxString &str, bool case_insensitive = false, const wxString &attr = wxEmptyString, bool matching = true);
};

#endif /* _MAPTABLE_H_ */
