//
// parseresult.h
//
#ifndef _PARSERESULT_H_
#define _PARSERESULT_H_

#include "common.h"
#include "wx/wx.h"
#include "wx/dynarray.h"

// G[R[h
typedef enum enumPrErrCode {
	prErrNone = 0,
	prErrInvalidChar,
	prErrInvalidUTF8Code,
	prErrInvalidBasicCode,
	prErrStopInvalidUTF8Code,
	prErrStopInvalidBasicCode,
} PrErrCode;

// ͌ʕۑNX
class ParseResultItem {
public:
	long line;
	long pos;
	long line_number;
	PrErrCode error_code;
	wxString name;
public:
	ParseResultItem();
	ParseResultItem(long new_line, long new_pos, long new_line_number, const wxString &new_name, PrErrCode new_error_code);
};
WX_DECLARE_OBJARRAY(ParseResultItem, ParseResultItems);

class ParseResult {
private:
	ParseResultItems items;
public:
	ParseResult();
	void Add(long new_line, long new_pos, long new_line_number, const wxString &new_name, PrErrCode new_error_code);
	void Empty();
	size_t GetCount();
	// G[bZ[W
	wxString ErrMsg(PrErrCode code);
	// |[go
	void Report(wxArrayString &lines);
};

#endif /* _PARSERESULT_H_ */
